// eslint-disable-next-line func-names
(function (Drupal, once, $) {
  Drupal.behaviors.IconifyIconsWidgetCollectionsFilter = {
    // eslint-disable-next-line no-unused-vars
    attach() {
      const $checkboxesFilter = $('.iconify-icons-widget-checkboxes-filter');
      const $collections = $('.iconify-icons-widget-collections');
      const $collectionGroups = $('.iconify-icons-widget-collections-group');

      // eslint-disable-next-line no-use-before-define
      $checkboxesFilter.on('keyup', handleFiltering);

      function handleFiltering() {
        const searchTerm = $(this).val().replace(/\s+/g, '').toLowerCase();
        const filterRegex = new RegExp(searchTerm, 'i');

        // eslint-disable-next-line func-names
        $collections.find('.form-item label.option').each(function () {
          const $label = $(this);
          const labelText = $label.text().replace(/\s+/g, '').toLowerCase();
          $label.parent().toggle(filterRegex.test(labelText));
        });

        // eslint-disable-next-line func-names
        $collectionGroups.each(function () {
          const $group = $(this);
          const groupLabelText = $group
            .text()
            .replace(/\s+/g, '')
            .toLowerCase();
          const allItemsHidden = $group
            .find('.form-item')
            .toArray()
            .every((item) => !$(item).is(':visible'));
          $group.toggle(!allItemsHidden || filterRegex.test(groupLabelText));
        });
      }
    },
  };
})(Drupal, once, jQuery);
